#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import shutil
import glob
import re



dir_to_remove = []
dir_to_remove.append("/opt/clonezilla")
dir_to_remove.append("/opt/ltsp")
dir_to_remove.append("/opt/tis")



file_to_remove = []
file_to_remove.append("/opt/debian-live/live/filesystem.dir/etc/skel/*.nxs")
file_to_remove.append("/opt/debian-live/live/filesystem.dir/etc/skel/Desktop/*.nxs")
file_to_remove.append("/opt/debian-live/live/filesystem.dir/etc/skel/Desktop/*.desktop")
file_to_remove.append("/opt/*tar.bz")

for folder in dir_to_remove:
    if os.path.exists(folder):
        shutil.rmtree(folder)
        
for file_remove in file_to_remove:
    for t in glob.glob(file_remove):
        if os.path.isfile(t):
            os.remove(t)
        

shutil.copyfile('/root/icaclient_12.0.0_i386.deb','/opt/debian-live/live/filesystem.dir/root/icaclient_12.0.0_i386.deb')
shutil.copyfile('/root/libmotif3_2.2.3-4_i386.deb','/opt/debian-live/live/filesystem.dir/root/libmotif3_2.2.3-4_i386.deb')

shutil.copyfile('/root/source.list','/opt/debian-live/live/filesystem.dir/etc/apt/source.list')
shutil.copyfile('/root/tisdeb.list','/opt/debian-live/live/filesystem.dir/etc/apt/sources.list.d/tisdeb.list')





shutil.copyfile('/root/repository.png','/opt/debian-live/live/filesystem.dir/usr/share/icons/repository.png')
shutil.copyfile('/root/ntp.conf','/etc/ntp.conf')
shutil.copyfile('/root/firefox.desktop','/opt/debian-live/live/filesystem.dir/etc/skel/Desktop/firefox.desktop')
shutil.copyfile('/root/Nouvelle_Connexion-CCCM.desktop','/opt/debian-live/live/filesystem.dir/etc/skel/Desktop/Nouvelle_Connexion-CCCM.desktop')

if os.path.exists('/opt/debian-live/live/filesystem.dir/etc/skel/.ICAClient'):
    shutil.rmtree('/opt/debian-live/live/filesystem.dir/etc/skel/.ICAClient')
shutil.copytree('/root/confCitrix','/opt/debian-live/live/filesystem.dir/etc/skel/.ICAClient')



def is_process_run(process_name):
    pids= [pid for pid in os.listdir('/proc') if pid.isdigit()]
    for pid in pids:
        if process_name in open(os.path.join('/proc', pid, 'cmdline'), 'rb').read():
            process_run = True
            return process_run

def choose_dhcp_file():
    if is_process_run("dhcpd3"):
        dhcp_file = "/etc/dhcp3/dhcpd.conf"
    else:
        dhcp_file = "/etc/dhcp/dhcpd.conf"
    return dhcp_file


def remove_ldap():
    if is_process_run("slapd"):
        if os.path.isfile("/etc/init.d/slapd"):
            os.remove("/etc/init.d/slapd")

def remove_bind():
    if is_process_run("bind"):
        if os.path.isfile("/etc/init.d/bind9"):
            os.remove("/etc/init.d/bind9")    
    
def remove_tftp():
    if is_process_run("tftp"):
        if os.path.isfile("/etc/init.d/tftpd-hpa"):
            os.remove("/etc/init.d/tftpd-hpa")     
    
    

def read_dhcp_file():
    dhcp_file = choose_dhcp_file()
    conf = open(dhcp_file,"r").read()
    subnet = re.compile("subnet\s*(?P<subnet>\S*)\s*netmask\s*(?P<netmask>\S*)\s*{")
    router = re.compile("option routers\s*(?P<router>\S*);")
    domainname = re.compile('option domain-name\s*"(?P<domain>\S*)";')
    dnsserver = re.compile("option domain-name-servers\s*(?P<dnsserver>\S*);")
    bootfilename = re.compile('filename\s*"(?P<bootfilename>\S*)";')
    dhcprange = re.compile('range dynamic-bootp\s*(?P<dhcprangemin>\S*)\s*(?P<dhcprangemax>\S*);')
    reservation = re.compile("""host\s*(?P<hostname>\S*)\s*\{\s*hardware ethernet\s*(?P<mac>\S*);\s*fixed-address\s*(?P<ip>\S*);\s*\}""")
 
    params = {
      'domain':'',
      'dnsserver':'',
      'dnsforwarder':'8.8.8.8',
      'dhcprangemin':'',
      'dhcprangemax':'',
      'bootfilename':'',
      'reservations':'',
    }
    
    for exp in (subnet,router,bootfilename,dhcprange,domainname,dnsserver ):
        for r in exp.finditer(conf):
            print r.groupdict()
            params.update(r.groupdict())
      
        
    reservations=[]
    for r in reservation.finditer(conf):
        reservations.append("dhcp-host=%(mac)s,%(ip)s,%(hostname)s" % r.groupdict())
                
    params['reservations'] = '\n'.join(reservations)
        
    template = """\
    # Never forward plain names (without a dot or domain part)
    domain-needed
    
    # Set the domain option for dhcp 
    domain=%(domain)s
    
    # to set a default forward DNS server 
    
    dhcp-authoritative
    dhcp-leasefile=/var/tmp/dnsmasq.leases
    dhcp-range=%(dhcprangemin)s,%(dhcprangemax)s,24h
    dhcp-option=option:domain-search,%(domain)s
    dhcp-option=option:dns-server,%(dnsserver)s
    dhcp-option=option:router,%(router)s
    #dhcp-option=option:ntp-server,%(router)s
    
    # pour boot PXE
    enable-tftp
    
    # Set the root directory for files available via FTP.
    tftp-root=/tftpboot
    dhcp-boot=%(bootfilename)s
    
    server=%(dnsforwarder)s
    server=/%(domain)s/%(dnsserver)s
    
    
    # pour config auto proxy
    #dhcp-option=252,"http://proxy.%(domain)s/wpad.dat\\n"
    #srv-host=_wpad._tcp,proxy.%(domain)s,80
    #cname=wpad.%(domain)s,proxy.%(domain)s
    
    # reservations
    #dhcp-host=f0:7b:cb:30:a6:c1,192.168.90.55
    
    %(reservations)s
    
    """   
    myfile = open('/etc/dnsmasq.d/dns-dhcp.conf','w')
    myfile.write(template % params)
    myfile.close()
    shutil.move(dhcp_file,dhcp_file+'.old')
    
    
read_dhcp_file()
remove_ldap()
remove_bind()
remove_tftp()
